## Classes

<dl>
<dt><a href="#Field">Field</a> ⇐ <code>RxJsonSchemaTopLevel</code></dt>
<dd><p>Form Field Item</p></dd>
<dt><a href="#Form">Form</a></dt>
<dd></dd>
<dt><a href="#Schema">Schema</a> ⇐ <code>RxJsonSchema</code></dt>
<dd></dd>
<dt><a href="#Lodger">Lodger</a></dt>
<dd><p>The main API</p></dd>
</dl>

## Members

<dl>
<dt><a href="#plural">plural</a></dt>
<dd><p>Plurals. @todo use Intl</p></dd>
<dt><a href="#asRxDBType">asRxDBType</a> ⇒ <code>string</code></dt>
<dd><p>Converts a LodgerField type to RxDB compatible one</p>
<p>Explicatie:
DB-ul nu stie decat de tipurile primare:
-&gt; boolean, string, number, array, object
Schema noastra e mult mai detaliata</p></dd>
</dl>

## Interfaces

<dl>
<dt><a href="#LodgerForm">LodgerForm</a></dt>
<dd></dd>
<dt><a href="#LodgerSchema">LodgerSchema</a></dt>
<dd></dd>
</dl>

<a name="LodgerForm"></a>

## LodgerForm
**Kind**: global interface  
<a name="LodgerSchema"></a>

## LodgerSchema
**Kind**: global interface  
<a name="Field"></a>

## Field ⇐ <code>RxJsonSchemaTopLevel</code>
<p>Form Field Item</p>

**Kind**: global class  
**Extends**: <code>RxJsonSchemaTopLevel</code>  
**Implements**: <code>SchemaField</code>  
**Requires**: <code>module:[String]</code>  

* [Field](#Field) ⇐ <code>RxJsonSchemaTopLevel</code>
    * [._temp](#Field._temp)
        * [new _temp(data)](#new_Field._temp_new)

<a name="Field._temp"></a>

### Field.\_temp
**Kind**: static class of [<code>Field</code>](#Field)  
<a name="new_Field._temp_new"></a>

#### new \_temp(data)
<p>Creates an instance of Field.</p>


| Param | Type |
| --- | --- |
| data | <code>FieldCreator.&lt;T&gt;</code> | 

<a name="Form"></a>

## Form
**Kind**: global class  
**Implements**: [<code>LodgerForm</code>](#LodgerForm)  

* [Form](#Form)
    * [new Form()](#new_Form_new)
    * _instance_
        * [.fakeData](#Form+fakeData)
        * [.data](#Form+data) ⇒ <code>Object</code>
        * [.fieldsIds](#Form+fieldsIds) ⇒ <code>Array.&lt;string&gt;</code>
        * [.onsubmit](#Form+onsubmit)
        * [.value()](#Form+value) ⇒ <code>Object</code>
    * _static_
        * [.Form](#Form.Form)
            * [new Form(data, [generateRxCollection])](#new_Form.Form_new)

<a name="new_Form_new"></a>

### new Form()
<p>Lodder Form class</p>

<a name="Form+fakeData"></a>

### form.fakeData
<p>Fakes data for testing</p>

**Kind**: instance property of [<code>Form</code>](#Form)  
**Read only**: true  
<a name="Form+data"></a>

### form.data ⇒ <code>Object</code>
<p>Makes a Vue-ready $data {object} suitable to be completed
by the user in the frontend -&gt; new form
(as it will turn reactive)</p>

**Kind**: instance property of [<code>Form</code>](#Form)  
**Read only**: true  
<a name="Form+fieldsIds"></a>

### form.fieldsIds ⇒ <code>Array.&lt;string&gt;</code>
<p>Quick access to all fields' ids</p>

**Kind**: instance property of [<code>Form</code>](#Form)  
**Read only**: true  
<a name="Form+onsubmit"></a>

### form.onsubmit
<p>register a new onsubmit function</p>

**Kind**: instance property of [<code>Form</code>](#Form)  
<a name="Form+value"></a>

### form.value() ⇒ <code>Object</code>
<p>Gets the value of current active form</p>

**Kind**: instance method of [<code>Form</code>](#Form)  
**Summary**: <p>for new forms, values are all undefined</p>  
**Returns**: <code>Object</code> - <p>data item (Vue $data - ready)</p>  
<a name="Form.Form"></a>

### Form.Form
**Kind**: static class of [<code>Form</code>](#Form)  
<a name="new_Form.Form_new"></a>

#### new Form(data, [generateRxCollection])
<p>Creates an instance of Form.</p>


| Param | Type | Default | Description |
| --- | --- | --- | --- |
| data | <code>LodgerFormCreator</code> |  | <p>Form input data</p> |
| [generateRxCollection] | <code>boolean</code> | <code>true</code> | <p>some forms don't require this</p> |

<a name="Schema"></a>

## Schema ⇐ <code>RxJsonSchema</code>
**Kind**: global class  
**Extends**: <code>RxJsonSchema</code>  
**Implements**: [<code>LodgerSchema</code>](#LodgerSchema)  

* [Schema](#Schema) ⇐ <code>RxJsonSchema</code>
    * [new Schema()](#new_Schema_new)
    * [.module.exports](#Schema.module.exports)
        * [new module.exports(form, [addCommonMethods])](#new_Schema.module.exports_new)
    * [.add(field)](#Schema.add)

<a name="new_Schema_new"></a>

### new Schema()
<p>s</p>

<a name="Schema.module.exports"></a>

### Schema.module.exports
**Kind**: static class of [<code>Schema</code>](#Schema)  
<a name="new_Schema.module.exports_new"></a>

#### new module.exports(form, [addCommonMethods])
<p>Constructs a valid RxJsonSchema out of a Lodger Form Data item</p>

**Returns**: <code>RxJsonSchema</code> - <p>schema</p>  

| Param | Type |
| --- | --- |
| form | <code>LodgerFormCreator</code> | 
| [addCommonMethods] | <code>boolean</code> | 

<a name="Schema.add"></a>

### Schema.add(field)
<p>Adds properties programatically as
we also need to fill in the required array</p>

**Kind**: static method of [<code>Schema</code>](#Schema)  

| Param | Type |
| --- | --- |
| field | <code>FieldCreator</code> | 

<a name="Lodger"></a>

## Lodger
<p>The main API</p>

**Kind**: global class  
**Implements**: <code>LodgerAPI</code>  
**Requires**: <code>module:&lt;rxdb&gt;</code>  

* [Lodger](#Lodger)
    * [Taxonomy.put

Inserts/updates a new document in DB
updates if data has ._id key(taxonomie, data)](#Taxonomy.put

Inserts/updates a new document in DB
updates if data has ._id key) ⇒ <code>Promise.&lt;RxDocument.&lt;Taxonomie&gt;&gt;</code>
    * _static_
        * [._temp](#Lodger._temp)
            * [new _temp()](#new_Lodger._temp_new)
            * [.translate](#Lodger._temp+translate) ⇒ <code>string</code>
        * [._temp#subscribe()](#Lodger._temp+subscribe) ⇒ <code>void</code>

<a name="Taxonomy.put

Inserts/updates a new document in DB
updates if data has ._id key"></a>

### LodgerTaxonomy.put

Inserts/updates a new document in DB
updates if data has .\_id key(taxonomie, data) ⇒ <code>Promise.&lt;RxDocument.&lt;Taxonomie&gt;&gt;</code>

| Param | Type |
| --- | --- |
| taxonomie | <code>Taxonomie</code> | 
| data | <code>Taxonomy.&lt;Taxonomie&gt;</code> | 

<a name="Lodger._temp"></a>

### Lodger.\_temp
**Kind**: static class of [<code>Lodger</code>](#Lodger)  

* [._temp](#Lodger._temp)
    * [new _temp()](#new_Lodger._temp_new)
    * [.translate](#Lodger._temp+translate) ⇒ <code>string</code>

<a name="new_Lodger._temp_new"></a>

#### new \_temp()
<p>Creates an instance of Lodger.</p>

<a name="Lodger._temp+translate"></a>

#### _temp.translate ⇒ <code>string</code>
<p>Gets the translation for a specific item.</p>

**Kind**: instance property of [<code>\_temp</code>](#Lodger._temp)  

| Param | Type |
| --- | --- |
| key | <code>string</code> | 

<a name="Lodger._temp+subscribe"></a>

### Lodger.\_temp#subscribe() ⇒ <code>void</code>
<p>Subscribes to multiple taxonomies with
same criteria</p>

**Kind**: static method of [<code>Lodger</code>](#Lodger)  
<a name="plural"></a>

## plural
<p>Plurals. @todo use Intl</p>

**Kind**: global variable  
<a name="asRxDBType"></a>

## asRxDBType ⇒ <code>string</code>
<p>Converts a LodgerField type to RxDB compatible one</p>
<p>Explicatie:
DB-ul nu stie decat de tipurile primare:
-&gt; boolean, string, number, array, object
Schema noastra e mult mai detaliata</p>

**Kind**: global variable  
**Returns**: <code>string</code> - <ul>
<li>tipul primar, eg. 'string'</li>
</ul>  
<a name="Errors"></a>

## Errors : <code>enum</code>
<p>Errors Definition</p>

**Kind**: global enum  
**Read only**: true  
**Todo**

- [ ] account for translations

<a name="strings"></a>

## strings : <code>enum</code>
<p>Accepted -strings- for a LodgerSchema field's type</p>

**Kind**: global enum  
<a name="Taxonomii"></a>

## Taxonomii : <code>enum</code>
<p>Taxonomies</p>

**Kind**: global enum  
<a name="Forms"></a>

## Forms : <code>enum</code>
<p>Forms, includes each for Taxonomies</p>

**Kind**: global enum  
